<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.2.1/dist/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <link rel="icon" href="data:,">
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.14.6/dist/umd/popper.min.js" integrity="sha384-wHAiFfRlMFy6i5SRaxvfOCifBUQy1xHdJ/yoi7FRNXMRBu5WHdZYu1hA6ZOblgut" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.2.1/dist/js/bootstrap.min.js" integrity="sha384-B0UglyR+jN6CkvvICOB2joaf5I4l3gm9GU6Hc1og6Ls7i6U/mkkaduKaBhlAXv9k" crossorigin="anonymous"></script>

    <title>Links</title>
    <style>
        .container_class {
            max-width: 900px;
            margin: 0 auto;
            padding: 20px;
            background-color: #f5f5f5;
            border-radius: 5px;
            box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
        }

        .link_item {
            margin-bottom: 10px;
            padding: 10px;
            background-color: #fff;
            border-radius: 3px;
            box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
        }

        .link_name {
            font-size: 18px;
            font-weight: bold;
            margin-bottom: 5px;
        }

        .link_status {
            font-size: 14px;
            color: #888;
        }

        .link_status.true {
            color: green;
        }

        .link_status.false {
            color: red;
        }

        .last_checked_marker.true::before {
            content: "✔";
            color: green;
        }

        .last_checked_marker.false::before {
            content: "✖";
            color: red;
        }

        .check_interval_form {
            display: flex;
            align-items: center;
            margin-top: 10px;
        }

        .check_interval_label {
            margin-right: 10px;
        }

        .check_interval_input {
            width: 60px;
        }

        .check_interval_button {
            margin-left: 10px;
        }
        .table {
    width: 100%;
    border-collapse: collapse;
    font-family: Arial, sans-serif;
  }

  .table thead {
    background-color: #f8f8f8;
  }

  .table th,
  .table td {
    padding: 8px;
    border: 1px solid #ddd;
  }
  .status-ok {
  color: green;
}

.status-error {
  color: red;
}
  .table th {
    font-weight: bold;
    text-align: left;
  }

  .table-striped tbody tr:nth-of-type(odd) {
    background-color: #f2f2f2;
  }
  .switch-label {
  display: inline-block;
  width: 40px;
  height: 20px;
  background-color: #ccc;
  border-radius: 10px;
  position: relative;
  cursor: pointer;
}

.switch-label:before {
  content: "";
  position: absolute;
  top: 2px;
  left: 2px;
  width: 16px;
  height: 16px;
  background-color: white;
  border-radius: 50%;
  transition: 0.2s;
}

.switch-input:checked + .switch-label {
  background-color: #6dbb63;
}

.switch-input:checked + .switch-label:before {
  transform: translateX(20px);
}
.switch-label {
  display: inline-block;
  width: 40px;
  height: 20px;
  background-color: #ccc;
  border-radius: 10px;
  position: relative;
  cursor: not-allowed;
}

.switch-label:before {
  content: "";
  position: absolute;
  top: 2px;
  left: 2px;
  width: 16px;
  height: 16px;
  background-color: white;
  border-radius: 50%;
  transition: 0.2s;
}

.switch-input:checked + .switch-label {
  background-color: #6dbb63;
}

.switch-input:checked + .switch-label:before {
  transform: translateX(20px);
}

.switch-label:disabled {
  background-color: #6dbb63;
  cursor: not-allowed;
  opacity: 0.6;
}

.switch-label:disabled:before {
  background-color: white;
}

.switch-label:disabled:hover {
  background-color: #6dbb63;
  opacity: 0.6;
}

.switch-label:disabled:hover:before {
  transform: translateX(20px);
}

    </style>
</head>
<form action="{% url 'sign-out' %}" method="POST">
  {% csrf_token %}
  <button type="submit" class="btn">Sign Out</button>
</form>
<body>
 <div class="container_class">
        {% for url in urls %}
  <div class="link_item">
    <p class="link_name">{{ url.name }}</p>
    <p class="link_status {% if url.status %}true{% else %}false{% endif %}">Status: {% if url.status %}OK{% else %}Error{% endif %}</p>
    <form>
        {% csrf_token %}
        <label for="pause_check">Keep updating status:</label>
        <input type="checkbox" name="pause_check" id="pause_check" {% if url.pause_check %}checked{% endif %} >
        <button type="button" class="pause_check" data-url-id="{{ url.id }}">Switch</button>
    </form>
    <p>URL: {{ url.url_link }}</p>
    <p id="interval_check_value_{{ url.id }}" class="last_checked">Interval check: {{ url.check_interval }}</p>
    <form class="check_interval_form" data-url-id="{{ url.id }}">
      {% csrf_token %}
      <label for="check_interval" class="check_interval_label">Edit Interval:</label>
      <input type="number" name="check_interval" id="check_interval_{{ url.id }}" class="check_interval_input" value="{{ url.check_interval }}">
      <button type="button" class="check_interval_button">Save</button>
    </form>
  </div>
  {% endfor %}
    </div>

    <script>

$(document).ready(function() {
  $('.pause_check').on('click', function() {
    
    var button = $(this);
    
    var urlId = button.data('url-id');


    $.ajax({
      type: 'POST',
      url: '/update-pause-status/' + urlId + '/',
      data: {

        csrfmiddlewaretoken: '{{ csrf_token }}'
      },
      success: function(response) {
        if (response.success) {
          button.toggleClass('active');

          var checkbox = button.siblings('#pause_check');
          
          checkbox.prop('checked', !checkbox.prop('checked'));
        } 
        else {
          console.log('Failed to toggle the pause_check field.');
        }
      },
      error: function(xhr, status, error) {
        console.log('An error occurred while toggling the pause_check field:', error);
      }
    });
  });
});









$(document).ready(function() {
    $('#postButton').on('click', function() {
      var urlId = '{{ url.id }}'; 




      var isChecked = $('#toggleSwitch').is(':checked');


      $.ajax({
        type: 'POST',
      
        url: '/update-pause-status/', 
        data: {
          url_id: urlId,
          pause_check: !isChecked
        },
        headers: {
          'X-CSRFToken': '{{ csrf_token }}' 
        },
        success: function(response) {
          isChecked = !isChecked;

          $('#toggleSwitch').prop('checked', isChecked);
        },

        error: function(xhr, status, error) {
        }
      });
    });
  });

$(document).ready(function() {
  $('#postButton').on('click', function() {
    var urlId = '{{ url.id }}'; 
    $.ajax({
      type: 'POST',
      url: '/your-post-url/', 
      data: {
        urlId: urlId,   

        key1: 'value1',  
        key2: 'value2',
      }, 
      headers: {
        'X-CSRFToken': '{{ csrf_token }}' 
      },
      success: function(response) {
        console.log('POST request successful');
      },
      error: function(xhr, status, error) {
        console.log('Error:', error);
      }
    });
  });
});


$(document).ready(function() {
  $('.link_item').each(function() {
    const linkItem = $(this);
    const urlId = linkItem.find('.check_interval_form').data('url-id');
    const linkStatus = linkItem.find('.link_status');
    let intervalId;

    let pauseCheck = linkItem.find('.pause_check').is(':checked');


    let checkInterval = parseInt(linkItem.find('.check_interval_input').val());

    function updateLinkStatus() {
      const url = `/status_check/${urlId}/`;
      $.ajax({

        type: 'GET',
        
        url: url,
        success: function(response) {
          if (response.success) {
            linkStatus.text('Status: OK').removeClass('false').addClass('true');
          } else {
            linkStatus.text('Status: Error').removeClass('true').addClass('false');
          }
        },
        error: function(xhr, status, error) {

          console.log('An error occurred while updating the link status:', error);
        }
      });
    }

    function scheduleNextCheck() {
      if (!pauseCheck) {
        updateLinkStatus();

        intervalId = setInterval(updateLinkStatus, checkInterval * 1000);
      }
    }

    const button = linkItem.find('.check_interval_button');
    const form = linkItem.find('.check_interval_form');
    const intervalCheckValue = linkItem.find('.last_checked');

    button.off('click');

    button.on('click', function() {
      const newCheckInterval = form.find('.check_interval_input').val();
      const url = `/save-check-interval/${urlId}/`;
      const data = {
        'check_interval': newCheckInterval
      };

      $.ajax({
        type: 'POST',
        url: url,
        data: JSON.stringify(data),
        headers: {
          'Content-Type': 'application/json',
          'X-CSRFToken': '{{ csrf_token }}'
        },
        success: function(response) {
          intervalCheckValue.text(`Interval check: ${newCheckInterval}`);

          clearInterval(intervalId);
          checkInterval = parseInt(newCheckInterval);
          scheduleNextCheck();
        },
        error: function(xhr, status, error) {
          console.log('An error occurred while saving the check interval:', error);
        }
      });
    });

    const initialCheckInterval = parseInt(linkItem.find('.check_interval_input').val());
    scheduleNextCheck();

    linkItem.find('.pause_check').on('click', function() {
      pauseCheck = !pauseCheck;
      if (pauseCheck) {
        clearInterval(intervalId);
      } else {
        scheduleNextCheck();
      }
    });
  });
});

document.addEventListener('DOMContentLoaded', function() {
    const buttons = document.querySelectorAll('.check_interval_button');

    buttons.forEach(button => {
        button.addEventListener('click', function() {
            const form = this.parentNode;

            const intervalInput = form.querySelector('.check_interval_input');
            const checkInterval = intervalInput.value;
            const urlId = form.getAttribute('data-url-id');
            
            const url = `/save-check-interval/${urlId}/`;
            const data = {
                'check_interval': checkInterval
            };

            fetch(url, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'X-CSRFToken': '{{ csrf_token }}'
                },
                body: JSON.stringify(data),
            })
            .then(response => response.json())
            .then(data => {
                if (data.success) {
                    const intervalCheckValue = form.parentNode.querySelector('.last_checked');
                    intervalCheckValue.innerText = `Interval check: ${checkInterval}`;
                } else {
                }
            })
            .catch(error => {
            });
        });
    });
});
    </script>
</body>
</html>